MODULE Def2Hyp;

FROM GEMX IMPORT BasePagePtr;

FROM SYSTEM IMPORT VAL;

FROM InOut IMPORT WriteString, ReadLine, OpenInput,CloseInput, OpenOutput,
                  CloseOutput,Done,WriteLn, WriteCard;

FROM DynStrings IMPORT MemoryError;

FROM Liste IMPORT MakeList, KillList, Empty, AtLast,GetValue, SetValue,
                  Next, First, List,AppendElement, EnterElement,ListError;

FROM pSTRING IMPORT ASSIGN, SLEN, LPOS, RPOS, DELETE, CONCAT,COPY,LPOSCHRSET;

VAR StrLst: List;
VAR Datei : ARRAY [0..127] OF CHAR;

PROCEDURE IndexUndLabelEinfuegen;

VAR ToFind : ARRAY [1..10] OF CHAR;
	ok : BOOLEAN;
    OutStr : ARRAY [0..255] OF CHAR;
    IndexStr, LabelStr, ModuleNameStr : ARRAY [0..80] OF CHAR;
    Position : INTEGER;
    ProcBegPos : INTEGER;
    ProcEndPos : INTEGER;
    ProcName : ARRAY [1..60] OF CHAR;
    BegProc : ARRAY [0..52] OF CHAR;
    EndProc : ARRAY [0..3] OF CHAR;
    
PROCEDURE InsertHypertextCmd(DoFind, Insert1, Insert2 :ARRAY OF CHAR;
				ExitWhenFound : BOOLEAN);
BEGIN
     ASSIGN(DoFind,ToFind);
     LOOP
       ok:=GetValue(StrLst,OutStr);
       IF ok THEN
          Position:=LPOS(0,ToFind,OutStr);
          IF (Position >=0) THEN
              (*WriteString(OutStr);WriteCard(Position,3);
              WriteLn;*)
              (*IndexStr:=Insert2;
              LabelStr:=Insert1;*)
              ASSIGN(Insert2,IndexStr);
              ASSIGN(Insert1,LabelStr);
              ProcName:="";
              ProcBegPos:=LPOSCHRSET(Position + VAL(INTEGER,SLEN(ToFind)),BegProc,OutStr);
              ProcEndPos:=LPOSCHRSET(ProcBegPos,EndProc,OutStr);
              IF (ProcEndPos > ProcBegPos) THEN
                COPY(ProcBegPos,(ProcEndPos-ProcBegPos),OutStr,ProcName);
                CONCAT(IndexStr,ProcName,IndexStr);
                CONCAT(LabelStr,ProcName,LabelStr);
                    IF ExitWhenFound THEN
                       First(StrLst);
                    END(*IF*);   
                    EnterElement(StrLst);
                    SetValue(StrLst,LabelStr);
                    Next(StrLst);
                    EnterElement(StrLst);
                    SetValue(StrLst,IndexStr);
                    Next(StrLst);
                    WriteString(LabelStr); (*WriteString(IndexStr);*)
                    WriteLn;
                    IF ExitWhenFound THEN
                       RETURN 
                    END(*IF*);   
              END(*IF*);
          END(*IF*);
       END(*IF*);
       IF AtLast(StrLst) THEN EXIT; END(*IF*);
       Next(StrLst);
    END(*LOOP*);
END InsertHypertextCmd;				
    
BEGIN
    ToFind:=".";
    Position:=RPOS(SLEN(Datei),ToFind,Datei)+1;
    COPY(0,Position,Datei,Datei);
    COPY(RPOS(SLEN(Datei),'\',Datei)+1,Position,Datei,ModuleNameStr);
    CONCAT(ModuleNameStr,'MOD/main}',ModuleNameStr);
    CONCAT(Datei,"D2H",Datei);
    CONCAT('@{"(* IMPLEMENTATION *)" link ',ModuleNameStr,ModuleNameStr);
    BegProc:="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
    EndProc:=" (;";
    First(StrLst);
    IF ~Empty(StrLst) THEN
       WriteString(" Index und Label einfuegen");WriteLn;
       InsertHypertextCmd('MODULE ','@node "MODULE ','@alias ',TRUE);
       EnterElement(StrLst);
       SetValue(StrLst,ModuleNameStr);
       IndexStr:="@index ";
       LabelStr:="@alabel ";
       First(StrLst);
       ToFind :="PROCEDURE ";
       InsertHypertextCmd(ToFind,LabelStr,IndexStr,FALSE); 
    END(*IF*);
END  IndexUndLabelEinfuegen;


PROCEDURE DateiEinlesen(VAR  InDatei: ARRAY OF CHAR);
VAR (*Datei : ARRAY [0..127] OF CHAR;*)
    (* ok: BOOLEAN; *)
    InStr : ARRAY [0..255] OF CHAR;
BEGIN
    DELETE(0,1,InDatei);
    WriteString(InDatei);WriteLn;
    ASSIGN(InDatei,Datei);
    IF (SLEN(Datei)>0) THEN
        OpenInput(InDatei);
        First(StrLst);
        WHILE (Done AND (~ListError AND ~MemoryError)) DO
           ReadLine(InStr);
           IF (SLEN(InStr)>0) THEN
             AppendElement(StrLst);
             SetValue(StrLst,InStr);
           ELSE
             InStr:="@endnode ";
             AppendElement(StrLst);
             SetValue(StrLst,InStr);
           END(*IF*);
        END(*WHILE*);
        CloseInput;
   END(*IF*);
END DateiEinlesen;

PROCEDURE DateiAusgeben;
VAR (*Datei : ARRAY [0..127] OF CHAR;*)
    ok : BOOLEAN;
    OutStr : ARRAY [0..255] OF CHAR;
BEGIN
    WriteString(Datei);
    WriteLn;
    OpenOutput(Datei);
    First(StrLst);
    IF ~Empty(StrLst) THEN
    LOOP
       ok:=GetValue(StrLst,OutStr);
       IF ok THEN
          WriteString(OutStr);
          WriteLn;
       END(*IF*);
       IF AtLast(StrLst) THEN EXIT; END(*IF*);
       Next(StrLst);
    END(*LOOP*);
    END(*IF*);
    CloseOutput;
END DateiAusgeben;

BEGIN
    MakeList(StrLst);
    DateiEinlesen(BasePagePtr^.CmdLine);
    IF (~ListError AND ~MemoryError) THEN
      IndexUndLabelEinfuegen;
    END(*IF*);
    IF (~ListError AND ~MemoryError) THEN
       DateiAusgeben;
    ELSE
       WriteString("Memory Error - No Output written");
       WriteLn;
    END(*IF*);
    KillList(StrLst);

END Def2Hyp.
