MODULE Def2Hyp1;

FROM GEMX IMPORT BasePagePtr;

FROM InOut IMPORT WriteString, ReadLine, OpenInput,CloseInput, OpenOutput,
                  CloseOutput,Done,WriteLn, WriteCard;

FROM DynStrings IMPORT MemoryError;

FROM Liste IMPORT MakeList, KillList, Empty, AtLast,GetValue, SetValue,
                  Next, First, List,AppendElement, EnterElement,ListError;

FROM Strings IMPORT Assign, IsEmptyStr,Length,LeftPos,RightPos,Delete, Concat,SubStr;

FROM XStrings IMPORT LeftPosInSet;

VAR StrLst: List;
VAR Datei : ARRAY [0..127] OF CHAR;

PROCEDURE IndexUndLabelEinfuegen;

VAR ToFind : ARRAY [1..10] OF CHAR;
    OKp,OKl,OKi,ok : BOOLEAN;
    OutStr : ARRAY [0..255] OF CHAR;
    IndexStr, LabelStr, ModuleNameStr : ARRAY [0..80] OF CHAR;
    Position : CARDINAL;
    ProcBegPos : CARDINAL;
    ProcEndPos : CARDINAL;
    ProcName : ARRAY [1..60] OF CHAR;
    BegProc : ARRAY [0..52] OF CHAR;
    EndProc : ARRAY [0..3] OF CHAR;
    
PROCEDURE InsertHypertextCmd(DoFind, Insert1, Insert2 :ARRAY OF CHAR;
				ExitWhenFound : BOOLEAN);
BEGIN
     Assign(DoFind,ToFind,ok);
     LOOP
       ok:=GetValue(StrLst,OutStr);
       IF ok THEN
          Position:=LeftPos(ToFind,1,OutStr,TRUE);
          IF (Position >0) THEN
              (*WriteString(OutStr);WriteCard(Position,3);
              WriteLn;*)
              (*IndexStr:=Insert2;
              LabelStr:=Insert1;*)
              Assign(Insert2,IndexStr,ok);
              Assign(Insert1,LabelStr,ok);
              ProcName:="";
              ProcBegPos:=LeftPosInSet(BegProc,Position+Length(ToFind),OutStr,TRUE);
              ProcEndPos:=LeftPosInSet(EndProc,ProcBegPos,OutStr,TRUE);
              IF (ProcEndPos > ProcBegPos) THEN
                SubStr(OutStr,ProcBegPos,(ProcEndPos-ProcBegPos),ProcName,OKp);
                Concat(IndexStr,ProcName,IndexStr,OKi);
                Concat(LabelStr,ProcName,LabelStr,OKl);
                IF (OKi AND OKl AND OKp) THEN
                    IF ExitWhenFound THEN
                       First(StrLst);
                    END(*IF*);   
                    EnterElement(StrLst);
                    SetValue(StrLst,LabelStr);
                    Next(StrLst);
                    EnterElement(StrLst);
                    SetValue(StrLst,IndexStr);
                    Next(StrLst);
                    WriteString(LabelStr); (*WriteString(IndexStr);*)
                    WriteLn;
                    IF ExitWhenFound THEN
                       RETURN 
                    END(*IF*);   
                END(*IF*);
              END(*IF*);
          END(*IF*);
       END(*IF*);
       IF AtLast(StrLst) THEN EXIT; END(*IF*);
       Next(StrLst);
    END(*LOOP*);
END InsertHypertextCmd;				
    
BEGIN
    ToFind:=".";
    Position:=RightPos(ToFind,Length(Datei),Datei,TRUE);
    SubStr(Datei,1,Position,Datei,OKp);
    SubStr(Datei,RightPos('\',Length(Datei),Datei,TRUE)+1,Position,ModuleNameStr,OKp);
    Concat(ModuleNameStr,'MOD/main}',ModuleNameStr,OKi);
    Concat(Datei,"D2H",Datei,OKi);
    Concat('@{"(* IMPLEMENTATION *)" link ',ModuleNameStr,ModuleNameStr,OKi);
    BegProc:="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
    EndProc:=" (;";
    First(StrLst);
    IF ~Empty(StrLst) THEN
       WriteString(" Index und Label einfuegen");
       InsertHypertextCmd('MODULE ','@node "MODULE ','@alias ',TRUE);
       EnterElement(StrLst);
       SetValue(StrLst,ModuleNameStr);
       IndexStr:="@index ";
       LabelStr:="@alabel ";
       First(StrLst);
       ToFind :="PROCEDURE ";
       InsertHypertextCmd(ToFind,LabelStr,IndexStr,FALSE); 
    END(*IF*);
END  IndexUndLabelEinfuegen;


PROCEDURE DateiEinlesen(VAR  InDatei: ARRAY OF CHAR);
VAR (*Datei : ARRAY [0..127] OF CHAR;*)
    ok: BOOLEAN;
    InStr : ARRAY [0..255] OF CHAR;
BEGIN
    Delete(InDatei,1,1);
    WriteString(InDatei);WriteLn;
    Assign(InDatei,Datei,ok);
    IF (ok AND ~IsEmptyStr(Datei)) THEN
        OpenInput(InDatei);
        First(StrLst);
        WHILE (Done AND (~ListError AND ~MemoryError)) DO
           ReadLine(InStr);
           IF (Length(InStr)>0) THEN
             AppendElement(StrLst);
             SetValue(StrLst,InStr);
           ELSE
             InStr:="@endnode ";
             AppendElement(StrLst);
             SetValue(StrLst,InStr);
           END(*IF*);
        END(*WHILE*);
        CloseInput;
    END(*IF*);
END DateiEinlesen;

PROCEDURE DateiAusgeben;
VAR (*Datei : ARRAY [0..127] OF CHAR;*)
    ok : BOOLEAN;
    OutStr : ARRAY [0..255] OF CHAR;
BEGIN
    WriteString(Datei);
    WriteLn;
    (*Datei:="CON:";*)
    OpenOutput(Datei);
    First(StrLst);
    IF ~Empty(StrLst) THEN
    LOOP
       ok:=GetValue(StrLst,OutStr);
       IF ok THEN
          WriteString(OutStr);
          WriteLn;
       END(*IF*);
       IF AtLast(StrLst) THEN EXIT; END(*IF*);
       Next(StrLst);
    END(*LOOP*);
    END(*IF*);
    CloseOutput;
END DateiAusgeben;

BEGIN
    MakeList(StrLst);
    DateiEinlesen(BasePagePtr^.CmdLine);
    IF (~ListError AND ~MemoryError) THEN
      IndexUndLabelEinfuegen;
    END(*IF*);
    IF (~ListError AND ~MemoryError) THEN
       DateiAusgeben;
    ELSE
       WriteString("Memory Error - No Output written");
       WriteLn;
    END(*IF*);
    KillList(StrLst);

END Def2Hyp1.
