IMPLEMENTATION MODULE  M2Editor;
FROM pStorage IMPORT ALLOCATE, DEALLOCATE;
FROM GEMDOS IMPORT ExecMode, Exec,Term, GetDrv, GetPath,SetDrv, SetPath;
IMPORT GEMDOS;
IMPORT ConvertStr, Atari2Ascii, FileSystem;
FROM GEMX IMPORT BasePagePtr;
FROM Bios IMPORT DriveMap;
FROM SYSTEM IMPORT ADDRESS,VAL;
FROM pString IMPORT SLEN,COPY,EQUAL,DELETE;
FROM SYSTEM IMPORT SHORT;

IMPORT ObjectCache;

PROCEDURE  Edit;
TYPE
    Env = ARRAY [0..80] OF CHAR;
VAR
    ENVPTR : POINTER TO Env;
    Res :INTEGER;
    ok : BOOLEAN;
    Drive    : CARDINAL;
    PathName, ErrorFileName : ARRAY[0..127] OF CHAR;
    Extension : ARRAY   [0..4] OF CHAR;
    DrvMap :LONGINT;
    CMDLength : CARDINAL;

PROCEDURE TransformErrors(FileName : ARRAY OF CHAR);
CONST MaxLength = 2048D;

TYPE Buffer = ARRAY [0..2048] OF CHAR;

VAR BuffPtr : POINTER TO Buffer;
    FileHandle : INTEGER;
    f : FileSystem.File;
    length : LONGINT;
    OK : BOOLEAN;
    pos : LONGINT;
BEGIN
   pos:=0D;
   FileSystem.Lookup(f,FileName,FALSE);
   FileSystem.Length(f,length);
   IF f.errorno # 0 THEN RETURN (* Kein Error-File *) END(*IF*);
   IF  length < 0D THEN
       RETURN (* blo weg *)
   ELSIF length = 0D  THEN (* Kommt bei LPR manchmal vor *)
     (*  FileSystem.Delete(f); (* Errorfile lschen! *)
       DELETE(1,CMDLength-1,BasePagePtr^.CmdLine); *) (* den Namen des gelschten Files nicht bergeben! *)
       RETURN (* und Tsch *)
   END(*IF*);
   IF (length > MaxLength) THEN
          length:=MaxLength;
   END(*IF*);
   ALLOCATE( BuffPtr, length);
   IF BuffPtr#NIL THEN
      GEMDOS.Open(FileName,2,FileHandle);
      GEMDOS.Seek(0D,FileHandle,GEMDOS.beginning,pos);
      GEMDOS.Read(FileHandle,length,BuffPtr);
      IF Atari2Ascii.ErrConvert(BuffPtr^, SHORT(length)) THEN
         GEMDOS.Seek(0D,FileHandle,GEMDOS.beginning,pos);
         GEMDOS.Write(FileHandle,length,BuffPtr);
      END(*IF*);
      DEALLOCATE(BuffPtr, length);
      OK:=GEMDOS.Close(FileHandle);
   END(*IF*);
END TransformErrors;

BEGIN
     DrvMap :=VAL(LONGINT,DriveMap());
     GetDrv(Drive);
     GetPath(PathName,0);
     BasePagePtr^.CmdLine[0]:=" ";
     (*WriteString('*');
     WriteString(BasePagePtr^.CmdLine);
     WriteString('*');*)
     CMDLength:=SLEN(BasePagePtr^.CmdLine) DIV 2;
     (*WriteCard(CMDLength,3);*)
     COPY(1,CMDLength-1,BasePagePtr^.CmdLine,ErrorFileName);
     COPY(CMDLength-5,CMDLength-1,ErrorFileName,Extension);
     (*WriteString(Extension);WriteLn;*)
     IF EQUAL(Extension,'.ERR') THEN
        (*WriteString('!!!!');*)
        TransformErrors(ErrorFileName);
     END(*IF*);
(*     WriteString('*');
     WriteLn;
     WriteString(ErrorFileName);WriteString('*');
     WriteLn;
     WriteString('*-');
     Write(ErrorFileName[CMDLength-1]);
     WriteString('-*'); *)
     GetDrv(Drive);
     GetPath(PathName,0);
     SetDrv(Drive_Number,DrvMap);
     (* 0 = A: 1 = B: .... *)
     ok:=SetPath("\Path\");
     Exec(loadExecute,"X:\Path\EDITOR.PRG",BasePagePtr^.CmdLine,ENVPTR^,Res);
     SetDrv(Drive,DrvMap);
     ok:=SetPath(PathName);
     ConvertStr.IntToStr(Res,1,BasePagePtr^.CmdLine,ok);
END Edit;
BEGIN
Edit
END M2Editor.
